
	/*	  Rewritten by Mere Mortal on 3rd May 2016 @ PiratesAhoy.net	*/
	/*	 Modified to allow companions to transfer between one another.	*/

		//	This should not require other files to be modified,		\\
		//	with the only exception being to define OFFICER_MAX.	\\
		//	This should be rectified in the next release, please	\\
		//	remove this notice if and when such a change is made.	\\
		//	Set #DEFINE OFFICER_MAX 4 here or indeed as global.	\\

		//	This is in BETA condition, there are and may be some	\\
		//	outstanding bugs, but do let me know if you find any!	\\

ref MainChar
ref myCh
ref enemyCh
int refMainCh
int refMyCh
int refEnCh
ref refShip1
ref refShip2
int indShip1
int indShip2
int numShip1
int numShip2
int CompanionPlace
int CompanionIndex
int CompanionChar
int numScroll
int numFourImage
int allowtransfer
int bYesChange
int charQuantity
int oldCharIdx
int numPassenger
int indPassenger
int indOfficer
ref refPassenger
ref refOfficer
ref CharRef
int oldShowMode

int i
int n
int q

string oldCurNode = GetCurrentNode()

void InitInterface_RR(string iniName, ref myCh, ref enemyCh)
{
	MainChar = GetMainCharacter()

	refShip1 = myCh
	refShip2 = enemyCh

	indShip1 = GetCompanionIndex(refShip1,0) // These are the
	indShip2 = GetCompanionIndex(refShip2,0) // ship indexes
	numShip1 = GetCompanionNumber(MainChar,indShip1) // These are the
	numShip2 = GetCompanionNumber(MainChar,indShip2) // companion numbers

    GameInterface.title = "titleAssignOfficers"

	FillScroll()
	FillFourImages()
    SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName)
	CreateExitString()

	CreateString(EnableLimitedShipClass(), "MaxShipClass","",FONT_NORMAL,COLOR_NORMAL,320,435,SCRIPT_ALIGN_CENTER,0.8)
    CreateString(true,"CharacterName","",	FONT_NORMAL,COLOR_NORMAL,320,194,SCRIPT_ALIGN_CENTER,1)
    CreateString(true,"SkillLeadership","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,300,224,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillFencing","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,300,258,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillSailing","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,300,292,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillAccuracy","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,300,326,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillCannons","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,300,358,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillGrappling","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,434,224,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillRepair","",		FONT_BOLD_NUMBERS,COLOR_NORMAL,434,258,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillDefence","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,434,292,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillCommerce","",	FONT_BOLD_NUMBERS,COLOR_NORMAL,434,326,SCRIPT_ALIGN_RIGHT,1)
    CreateString(true,"SkillSneak","",		FONT_BOLD_NUMBERS,COLOR_NORMAL,434,358,SCRIPT_ALIGN_RIGHT,1)

	onChange()

	SetEventHandler("InterfaceBreak","ProcessCancelExit",0)
	SetEventHandler("InterfaceCancel","ProcessCancelExit",0)
	SetEventHandler("RemovePress","RemoveProcess",0)
	SetEventHandler("SelectPassenger","SelectPassenger",0)
	SetEventHandler("ProceedShipAssignment","CheckProceedShipAssignment",0)
	SetEventHandler("MaxShipClassNo","CheckMaxShipClassNo",0)
	SetEventHandler("TransferCaptainYes","TransferCaptainYes",0)
	SetEventHandler("TransferCaptainNo","TransferCaptainNo",0)
	SetEventHandler("ChangeOfficerRole","ProcessChangeRole",0)
	SetEventHandler("SelectedFirstMate","SelectFirstMate",0)
	SetEventHandler("SelectedNavigator","SelectNavigator",0)
	SetEventHandler("SelectedGunner","SelectGunner",0)
	SetEventHandler("SelectedBoatswain","SelectBoatswain",0)
	SetEventHandler("SelectedDoctor","SelectDoctor",0)
	SetEventHandler("SelectedCarpenter","SelectCarpenter",0)
	SetEventHandler("SelectedQMaster","SelectQMaster",0)
	SetEventHandler("SelectedRemove","SelectRemove",0)
	SetEventHandler("SelectAbort","SelectAbort",0)
	SetEventHandler("frame","onChange",0)

	RefreshScreen()
}

void onChange()
{
	indPassenger = GetPassenger(refShip1,numScroll)
	indOfficer   = GetOfficersIndex(refShip2,numFourImage)
	refPassenger = GetCharacter(indPassenger)
	refOfficer   = GetCharacter(indOfficer)
	numPassenger = GetPassengerNumber(refShip1,indPassenger)

	if (oldCurNode != GetCurrentNode()) {
		oldCurNode  = GetCurrentNode()
		bYesChange = true
	}
	if (numScroll != sti(GameInterface.passengers_list.current)) {
		numScroll  = sti(GameInterface.passengers_list.current)
		bYesChange = true
	}
	if (numFourImage != sti(GameInterface.FourImage.current)) {		
		numFourImage  = sti(GameInterface.FourImage.current)
		bYesChange = true
	}

	if (bYesChange == true) {
		if (indOfficer > 0 && oldCurNode=="COMPAIN_LIST") {
			SetSelectable("REMOVE_BUTTON",GetRemovable(GetCharacter(indOfficer)))
			SetSelectable("CHANGE_OFFICER_ROLE",true)
		}
		if (indOfficer < 1 || oldCurNode=="PASSENGERS_LIST" || oldCurNode=="TITLE") {
			SetSelectable("REMOVE_BUTTON",false)
			SetSelectable("CHANGE_OFFICER_ROLE",false)
		}
		if (numFourImage == 0 && oldCurNode=="COMPAIN_LIST") {
			SetSelectable("REMOVE_BUTTON",false)
			SetSelectable("CHANGE_OFFICER_ROLE",false)
			if (charQuantity > 0 && indShip2 > 0 && !bSeaActive) {
				SetSelectable("REMOVE_BUTTON",true)
			}
		}
		if (oldCurNode == "PASSENGERS_LIST") {
			if (indPassenger >= 0) {
				SetChrSkillData(CharRef)
				CharRef = GetCharacter(indPassenger)
				SetShowMode(ISHOW_MODE_CHRSKILL)
				if (CheckAttribute(CharRef,"quest.officertype")) {
					GameInterface.strings.CharacterName = CharRef.name+" "+CharRef.lastname+" ("+XI_ConvertString("S"+CharRef.quest.officertype)+")"
				}
				else {
					GameInterface.strings.CharacterName = CharRef.name+" "+CharRef.lastname+" "+XI_ConvertString("S(Comrade-In-Arms)")
				}
			}
			else {
				SetSumSkillData()
				SetShowMode(ISHOW_MODE_SUMSKILL)
			}
		}
		if (oldCurNode == "COMPAIN_LIST") {
			if (indOfficer >= 0) {
				CharRef = GetCharacter(indOfficer)
				SetChrSkillData(CharRef)
				SetShowMode(ISHOW_MODE_CHRSKILL)
				GameInterface.strings.CharacterName = CharRef.name+" "+CharRef.lastname
			}
			else {
				SetSumSkillData()
				SetShowMode(ISHOW_MODE_SUMSKILL)
			}
		}
		if (oldCurNode=="TITLE") {
			SetSumSkillData()
			SetShowMode(ISHOW_MODE_SUMSKILL)
			GameInterface.strings.CharacterName = "Summary Skills"
		}
	}
}

void FillScroll()
{
	numScroll = -1
    GameInterface.passengers_list.current = 0
	GameInterface.passengers_list.NotUsed = 5
	GameInterface.passengers_list.ImagesGroup.t0 = "EMPTYFACE"
	FillFaceList("passengers_list.ImagesGroup",refShip1,0)
	FillFaceList("passengers_list.ImagesGroup",refShip1,2)
	FillFaceList("passengers_list.ImagesGroup",refShip1,3)
	FillFaceList("passengers_list.ImagesGroup",refShip2,0)
	FillFaceList("passengers_list.ImagesGroup",refShip2,1)
	GameInterface.passengers_list.BadTex1 = FindFaceGroupNum("passengers_list.ImagesGroup","EMPTYFACE")
}
void RefillScroll()
{
	if (CheckAttribute(GameInterface.passengers_list,"ListSize")) {
		charQuantity = sti(GameInterface.passengers_list.ListSize)
	}
	for (i=0; i<charQuantity; i++) {
		string attributeName = "passengers_list.pic"+(i+1)
		DeleteAttribute(&GameInterface, attributeName)
	}
	charQuantity = 0
	while (GetPassenger(refShip1,charQuantity) > 0) {
		charRef = GetCharacter(GetPassenger(refShip1,charQuantity))
		string attrName = "pic"+(charQuantity+1)
		if (!CheckAttribute(charRef,"FaceID")) {
			charRef.FaceID = 0 // error messages go away, don't come back another day
			LogIt("Faceless passenger ["+charRef.index+"] found - FaceID set to 0")
		}
		GameInterface.passengers_list.(attrName).img1 = GetFacePicName(charRef)
		GameInterface.passengers_list.(attrName).tex1 = FindFaceGroupNum("passengers_list.ImagesGroup","FACE128_"+charRef.FaceId)
		if (IsAnOfficer(refShip1,charRef)) {
			GameInterface.passengers_list.(attrName).str1 = "#Officer"
		}
		if (IsPrisoner(charRef)) {
			GameInterface.passengers_list.(attrName).str1 = "#Captive"
		}
		charQuantity++
	}
	GameInterface.passengers_list.ListSize = charQuantity
	if (bNewInterface) {
		GameInterface.passengers_list.BadPic1 = "emptyface_new"
	}
	else {
		GameInterface.passengers_list.BadPic1 = "emptyface"
	}
}
void FillFourImages()
{
    numFourImage = 0
	GameInterface.FourImage.current = 0
	GameInterface.FourImage.ImagesGroup.t0 = "EMPTYFACE"
	GameInterface.FourImage.BadOnePicture = "interfaces\empty_face.tga"
	FillFaceList("FourImage.ImagesGroup",refShip1,0)
	FillFaceList("FourImage.ImagesGroup",refShip1,2)
	FillFaceList("FourImage.ImagesGroup",refShip2,0)
	FillFaceList("FourImage.ImagesGroup",refShip2,1)
}
void RefillFourImages()
{
	for (i=0; i<OFFICER_MAX; i++) {
		string attrName = "pic"+(i+1)
		n = GetOfficersIndex(refShip2,i)
		if (n >= 0) {
			charRef = GetCharacter(n)
			if (!CheckAttribute(charRef,"FaceID")) {
				charRef.FaceID = 0 // error messages go away, don't come back another day
				LogIt("Faceless officer ["+n+"] found - FaceID set to 0")
			}
			SetNewPicture("TYPEPICT0","")
			SetNewPicture("TYPEPICT1","")
			SetNewPicture("TYPEPICT2","")
			SetNewPicture("TYPEPICT3","")
			GameInterface.FourImage.(attrName).img1 = GetFacePicName(charRef)
			GameInterface.FourImage.(attrName).tex1 = FindFaceGroupNum("FourImage.ImagesGroup","FACE128_"+charRef.FaceID)
		}
		else {
			if (bNewInterface) {
				GameInterface.FourImage.(attrName).img1 = "emptyface_new"
			}
			else {
				GameInterface.FourImage.(attrName).img1 = "emptyface"
				GameInterface.FourImage.(attrName).tex1 = FindFaceGroupNum("FourImage.ImagesGroup","EMPTYFACE")
			}
		}
		GameInterface.FourImage.(attrName).selected = true
	}
	if (DynamicInterfaceLevel() > 1)
	{
		for (i=0; i<OFFICER_MAX; i++) {
			n = GetOfficersIndex(refShip2,i)
			if (n >= 0) {
				string TYPEPICT = "TYPEPICT"+i
				charRef = GetCharacter(n)
				switch (CharRef.quest.officertype) {
					case OFFIC_TYPE_REGCAP:			SetNewPicture(TYPEPICT,"interfaces\blank_ship.tga"); break;
					case OFFIC_TYPE_CAPMERCHANT:	SetNewPicture(TYPEPICT,"interfaces\blank_ship.tga"); break;
					case OFFIC_TYPE_CAPPRIVATEER:	SetNewPicture(TYPEPICT,"interfaces\blank_ship.tga"); break;
					case OFFIC_TYPE_CAPNAVY:		SetNewPicture(TYPEPICT,"interfaces\blank_ship.tga"); break;
					case OFFIC_TYPE_CAPPIRATE:		SetNewPicture(TYPEPICT,"interfaces\blank_ship.tga"); break;
					case OFFIC_TYPE_PIRATE:			SetNewPicture(TYPEPICT,"interfaces\fighter.tga"); break;	
					case OFFIC_TYPE_ABORDAGE:		SetNewPicture(TYPEPICT,"interfaces\crew.tga"); break;	
					case OFFIC_TYPE_RANDCHAR:		SetNewPicture(TYPEPICT,"interfaces\crew.tga"); break;
					case OFFIC_TYPE_BOATSWAIN:		SetNewPicture(TYPEPICT,"interfaces\order.tga"); break;
					case OFFIC_TYPE_CANNONEER:		SetNewPicture(TYPEPICT,"interfaces\gunner.tga"); break;
					case OFFIC_TYPE_QMASTER:		SetNewPicture(TYPEPICT,"interfaces\quartermaster.tga"); break;
					case OFFIC_TYPE_NAVIGATOR:		SetNewPicture(TYPEPICT,"interfaces\navigator.tga"); break;
					case OFFIC_TYPE_FIRSTMATE:		SetNewPicture(TYPEPICT,"interfaces\officer.tga"); break;
					case OFFIC_TYPE_CARPENTER:		SetNewPicture(TYPEPICT,"interfaces\carpenter.tga"); break;
					case OFFIC_TYPE_DOCTOR:			SetNewPicture(TYPEPICT,"interfaces\doctor.tga"); break;
				}
			}
		}
	}
}

void doMove()
{
	if (numFourImage > 0 && !IsPrisoner(refPassenger)) {
		SetOfficersIndex(refShip2,numFourImage,indPassenger)
		if (indOfficer > 0) {
			ChangePassenger(refShip1,numPassenger,indOfficer)
			RemovePassenger(refShip2,refOfficer)
		}
		RemovePassenger(refShip1,refPassenger)
	}
	SetCurrentNode("COMPAIN_LIST")
	RefreshScreen()
}
void RemoveProcess()
{
	if (numFourImage > 0) {
		RemoveOfficersIndex(refShip2,refOfficer)
		AddPassenger(refShip1,refOfficer,-1)
		RemovePassenger(refShip2,refOfficer)
		SetCurrentNode("TITLE")
		RefreshScreen()
	}

	if (numFourImage == 0) {
		// Captains are being handled below
		SetNodeUsing("CHANGE_OFFICER_ROLE",false)
		SetNodeUsing("REMOVE_BUTTON",false)
		SetNodeUsing("CONFIRM_YES_BUTTON",true)
		SetNodeUsing("CONFIRM_NO_BUTTON",true)
		SetCurrentNode("CONFIRM_NO_BUTTON")		
		SetSelectable("LEFTSCROLLBUTTON",false)
		SetSelectable("RIGHTSCROLLBUTTON",false)
		SetSelectable("PASSENGERS_LIST",false)
		SetSelectable("COMPAIN_LIST",false)
		GameInterface.strings.CharacterName = "Swap Captain with Passenger?"
	}
}

void TransferCaptainYes()
{
/*	This is broken, I don't know why. As a result, the interface is
	deliberately bailing to avoid any complications. The ransacking
	menu is also leading to the original files instead. Basically,
	transferring captains may only be done on land; if done at sea
	or during boarding then there will be serious problems.	I really
	don't know what the problem is, but something is very wrong here. */

	if (indPassenger > 0) {
		SetCompanionIndex(MainChar,numShip2,indPassenger)
		ChangePassenger(refShip1,numPassenger,indOfficer)
		RemoveOfficersIndex(refShip1,indPassenger)
		IMoveOfficers(refShip2,refPassenger)
		ISetShipAttributes(refPassenger)
	}
	interfaceResultCommand = RC_INTERFACE_TRANSFER_MAIN_EXIT
	PostEvent("LaunchIAfterFrame",1,"sl","I_SHIP",2)
	EndCancelInterface(false)
}
void TransferCaptainNo()
{
	SetSelectable("LEFTSCROLLBUTTON",true)
	SetSelectable("RIGHTSCROLLBUTTON",true)
	SetSelectable("PASSENGERS_LIST",true)
	SetSelectable("COMPAIN_LIST",true)
	SetNodeUsing("CHANGE_OFFICER_ROLE",true)
	SetNodeUsing("REMOVE_BUTTON",true)
	SetNodeUsing("CONFIRM_YES_BUTTON",false)
	SetNodeUsing("CONFIRM_NO_BUTTON",false)
	SetCurrentNode("COMPAIN_LIST")
}

void ISetShipAttributes(ref chref)
{
	DeleteAttribute(chref,"ship")
	aref arToChar
	makearef(arToChar,chref.ship)
	aref arFromChar
	makearef(arFromChar,refShip2.ship)
	CopyAttributes(arToChar,arFromChar)
}
void IMoveOfficers(ref rFromChar, ref rToChar)
{
	// Could move this to CharacterUtilite.c
	for (i=1; i<OFFICER_MAX; i++) {
		SetOfficersIndex(rToChar,i,SetOfficersIndex(rFromChar,i,-1))
	}
}
bool IsAnOfficer(ref refShip, ref refChar)
{
	// This is different to the existing function because
	// instead of checking main player, it checks the ship.
	// It requires two inputs: ship and character to check.
	// As a bonus, it also returns the officer's number.

	if(CheckAttribute(refChar,"index")) {
		int indChar = sti(refChar.index)
		if (indChar >= 0) {
			for (i=0; i<OFFICER_MAX; i++) {
				if (GetOfficersIndex(refShip,i) == indChar) {
					return i
				}
			}
		}
	}
	return false
}
void MakeOfficersCaptive()
{
	for (i=0; i<GetNotCaptivePassengersQuantity(refShip1); i++) {
		ref refChar = GetCharacter(GetPassenger(refShip1,i))
		if (IsOfficer(refChar)) {
			if (CheckAttribute(refChar,"prisoned")) {
				if (refChar.prisoned == "1") {
					refChar.chr_ai.group = refChar.prisoned
				}
			}
			refChar.prisoned = true
		}
	}
}
void MakeOfficersFreed()
{
	for (i=0; i<GetPassengersQuantity(refShip1); i++) {
		ref refChar = GetCharacter(GetPassenger(refShip1,i))
		if (IsOfficer(refChar) && refChar.chr_ai.group == "0") {
			// Need to set a flag to check for existing captives
			refChar.chr_ai.group = "player"
			refChar.prisoned = false
		}
		if (IsOfficer(refChar) && refChar.chr_ai.group == "1") {
			refChar.chr_ai.group = "player"
		}
	}
}

void SelectPassenger()
{
	if (!GetRemovable(refPassenger)) {return;}
	CheckProceedShipAssignment()
}
void CheckProceedShipAssignment()
{
	allowtransfer++
	if (EnableLimitedShipClass()) {
		ref Companion = GetCharacter(indPassenger)
		int compareskill = GetShipSkill(refShip1,SKILL_LEADERSHIP)
		Companion.prisoned = true
		ResetPartySkill(refShip1,SKILL_LEADERSHIP)
		ResetPartySkill(refShip1,SKILL_SAILING)

		switch(allowtransfer) {
			case 1:
				if (GetShipMinClassForCharacter(GetCharacter(indPassenger)) > GetCharacterShipClass(refShip2)) {
					SetNodeUsing("MSC_CONFIRM_RECTANGLE",true)
					SetNodeUsing("MSC_TEXTWINDOW",true)
					SetNodeUsing("MSC_CONFIRM_YES_BUTTON",true)
					SetNodeUsing("MSC_CONFIRM_NO_BUTTON",true)
					SetNodeUsing("MSC_SKILL_PIC",true)
					SetCurrentNode("MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,1,"MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,2,"MSC_CONFIRM_YES_BUTTON")
					SetFormatedText("MSC_TEXTWINDOW",TranslateString("","This officer has too low Leadership and Sailing skills to command this ship. Assign anyway?"))
				}
				else {
					CheckProceedShipAssignment()
				}
			break
			case 2:
				if (GetShipMinClassForCharacter(refShip1) > GetCharacterShipClass(refShip1)) {
					SetNodeUsing("MSC_CONFIRM_RECTANGLE",true)
					SetNodeUsing("MSC_TEXTWINDOW",true)
					SetNodeUsing("MSC_CONFIRM_YES_BUTTON",true)
					SetNodeUsing("MSC_CONFIRM_NO_BUTTON",true)
					SetNodeUsing("MSC_SKILL_PIC",true)
					SetCurrentNode("MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,1,"MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,2,"MSC_CONFIRM_YES_BUTTON")
					SetFormatedText("MSC_TEXTWINDOW",TranslateString("","By doing this, you won't be able to command your own ship anymore. Proceed?"))
				}
				else {
					CheckProceedShipAssignment()
				}
			break
			case 3:
				if (GetShipSkill(refShip1,SKILL_LEADERSHIP) < FLEETCOMMAND_MIN_LEVEL && CheckFleetShips(true) && GetShipSkill(refShip1,SKILL_LEADERSHIP) != compareskill) {
					SetNodeUsing("MSC_CONFIRM_RECTANGLE",true)
					SetNodeUsing("MSC_TEXTWINDOW",true)
					SetNodeUsing("MSC_CONFIRM_YES_BUTTON",true)
					SetNodeUsing("MSC_CONFIRM_NO_BUTTON",true)
					SetNodeUsing("MSC_SKILL_PIC",true)
					SetCurrentNode("MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,1,"MSC_CONFIRM_NO_BUTTON")
					SendMessage(&GameInterface,"lls",MSG_INTERFACE_LOCK_NODE,2,"MSC_CONFIRM_YES_BUTTON")
					SetFormatedText("MSC_TEXTWINDOW",TranslateString("","By doing this, you won't have enough leadership to command a fleet anymore. Proceed?"))
				}
				else {
					CheckProceedShipAssignment()
				}
			break
			case 4:
				CheckMaxShipClassYes()
			break
		}
		DeleteAttribute(Companion,"prisoned")
		ResetPartySkill(refShip1,SKILL_LEADERSHIP)
		ResetPartySkill(refShip1,SKILL_SAILING)
	}
	else {
		CheckMaxShipClassYes()
	}
}
void CheckMaxShipClassYes()
{
	if (EnableLimitedShipClass()) {
		SendMessage(&GameInterface,"ll",MSG_INTERFACE_LOCK_NODE,0)
		SetNodeUsing("MSC_CONFIRM_RECTANGLE",false)
		SetNodeUsing("MSC_TEXTWINDOW",false)
		SetNodeUsing("MSC_CONFIRM_YES_BUTTON",false)
		SetNodeUsing("MSC_CONFIRM_NO_BUTTON",false)
		SetNodeUsing("MSC_SKILL_PIC",false)
		SetCurrentNode("PASSENGERS_LIST")
	}
	doMove()
}
void CheckMaxShipClassNo()
{
	allowtransfer = 0
	SendMessage(&GameInterface,"ll",MSG_INTERFACE_LOCK_NODE,0)
	SetNodeUsing("MSC_CONFIRM_RECTANGLE",false)
	SetNodeUsing("MSC_TEXTWINDOW",false)
	SetNodeUsing("MSC_CONFIRM_YES_BUTTON",false)
	SetNodeUsing("MSC_CONFIRM_NO_BUTTON",false)
	SetNodeUsing("MSC_SKILL_PIC",false)
	SetCurrentNode("PASSENGERS_LIST")
}

void RefreshScreen()
{
	RefillScroll()
	RefillFourImages()
	SetSelectable("LEFTSCROLLBUTTON",true)
	SetSelectable("RIGHTSCROLLBUTTON",true)
	SetSelectable("PASSENGERS_LIST",true)
	SetSelectable("COMPAIN_LIST",true)
	SendMessage(&GameInterface,"ls",MSG_INTERFACE_REFRESH_SCROLL,"PASSENGERS_LIST")
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_FOURIMAGE_CHANGE,"COMPAIN_LIST",-1)
}
void ProcessCancelExit()
{
	DelEventHandler("frame","onChange")
	DelEventHandler("InterfaceBreak","ProcessCancelExit")
    DelEventHandler("InterfaceCancel","ProcessCancelExit")
	DelEventHandler("RemovePress","RemoveProcess")
	DelEventHandler("ProceedShipAssignment","CheckProceedShipAssignment")
	DelEventHandler("MaxShipClassNo","CheckMaxShipClassNo")
	DelEventHandler("ChangeOfficerRole","ProcessChangeRole")
	DelEventHandler("TransferCaptainYes","TransferCaptainYes")
	DelEventHandler("TransferCaptainNo","TransferCaptainNo")
	interfaceResultCommand = RC_INTERFACE_TRANSFER_MAIN_RETURN
	EndCancelInterface(true)
}

ref GetMyCharacterRef() {
	ref refMyCharacter = refShip1
	return refMyCharacter
}
ref GetEnemyCharacterRef() {
	ref refEnemyCharacter = refShip2
	return refEnemyCharacter
}

/* Ripped from passenger.c */

#define ISHOW_MODE_CAPTIVE	0
#define ISHOW_MODE_SUMSKILL	1
#define ISHOW_MODE_CHRSKILL	2

void SetShowMode(int sm)
{		
	if(oldShowMode==sm) {return;}
	switch(oldShowMode) {
		case ISHOW_MODE_CAPTIVE:
			DisableString("CharacterName")
			DisableString("CharacterNation")
			DisableString("RansomCost")
			SetNodeUsing("CAPTIVE_IMAGES",false)
			SetNodeUsing("CAPTIVE_STRINGS",false)
			SetNodeUsing("RELEASE_CAPTIVE",false)
			SetNodeUsing("RANSOM_CAPTIVE",false)
			SetNodeUsing("EXECUTE_CAPTIVE",false)
			SetNodeUsing("TEXTWINDOW",false)
			SetNodeUsing("CHANGE_OFFICER_ROLE",true)
			if (VISIT_DECK) {
				SetNodeUsing("REMOVE_OFFICER",true)
			}
		break
		case ISHOW_MODE_SUMSKILL:
			DisableString("skillLeadership")
			DisableString("skillFencing")
			DisableString("skillSailing")
			DisableString("skillAccuracy")
			DisableString("skillCannons")
			DisableString("skillGrappling")
			DisableString("skillRepair")
			DisableString("skillDefence")
			DisableString("skillCommerce")
			DisableString("skillSneak")
			SetNodeUsing("SUMMARYSTRINGS",false)
			SetNodeUsing("SUMMARYIMAGES",false)
		break
		case ISHOW_MODE_CHRSKILL:
			DisableString("skillLeadership")
			DisableString("skillFencing")
			DisableString("skillSailing")
			DisableString("skillAccuracy")
			DisableString("skillCannons")
			DisableString("skillGrappling")
			DisableString("skillRepair")
			DisableString("skillDefence")
			DisableString("skillCommerce")
			DisableString("skillSneak")
			DisableString("CharacterName")
			SetNodeUsing("SUMMARYIMAGES",false)
		break
	}
	oldShowMode = sm
	switch(sm) {
		case ISHOW_MODE_CAPTIVE:
			EnableString("CharacterName")
			EnableString("CharacterNation")
			EnableString("RansomCost");
			SetNodeUsing("CHANGE_OFFICER_ROLE",false)
			if (VISIT_DECK == 0) {
				SetNodeUsing("CAPTIVE_IMAGES",true)
				SetNodeUsing("RANSOM_CAPTIVE",true)
				SetNodeUsing("RELEASE_CAPTIVE",true)
				SetNodeUsing("CAPTIVE_STRINGS",true)
				SetNodeUsing("EXECUTE_CAPTIVE",true)
			}
			else {
				SetNodeUsing("TEXTWINDOW",true)
				SetNodeUsing("REMOVE_OFFICER",false)
				int tmpLangFileID = LanguageOpenFile("interface_strings.txt")
				SetFormatedText("TEXTWINDOW",LanguageConvertString(tmpLangFileID,"Prisoners"))
				LanguageCloseFile(tmpLangFileID)
			}
		break
		case ISHOW_MODE_SUMSKILL:
			EnableString("skillLeadership")
			EnableString("skillFencing")
			EnableString("skillSailing")
			EnableString("skillAccuracy")
			EnableString("skillCannons")
			EnableString("skillGrappling")
			EnableString("skillRepair")
			EnableString("skillDefence")
			EnableString("skillCommerce")
			EnableString("skillSneak")
			SetNodeUsing("SUMMARYSTRINGS",true)
			SetNodeUsing("SUMMARYIMAGES",true)
		break
		case ISHOW_MODE_CHRSKILL:
			EnableString("skillLeadership")
			EnableString("skillFencing")
			EnableString("skillSailing")
			EnableString("skillAccuracy")
			EnableString("skillCannons")
			EnableString("skillGrappling")
			EnableString("skillRepair")
			EnableString("skillDefence")
			EnableString("skillCommerce")
			EnableString("skillSneak")
			EnableString("CharacterName")
			SetNodeUsing("SUMMARYIMAGES",true)
		break
	}
}
void SetSumSkillData()
{
	string skill
	for (n=0; n<10; n++) {
		skill = GetSkillName(n)
		int skillval = GetShipSkill(refShip2,skill)
		int modval = CalcCharacterSkill(refShip2,skill)
		int color = COLOR_NORMAL
		skill = "skill"+skill
		GameInterface.strings.(skill) = skillval
		if (skillVal < modval)		{color = COLOR_RED;}
		if (skillVal > modval)		{color = COLOR_GREEN;}
		if (skillVal == SKILL_MAX)	{color = COLOR_MONEY;}
		if (skillVal == 0)			{color = COLOR_GRAY;}
		ChangeStringColor(skill,color)
	}
}
void SetChrSkillData(ref chref)
{
	string skill
	for (n=0; n<10; n++) {
		skill = GetSkillName(n)
		int skillval = GetEffectiveSkill(chref,skill)
		int modval = CalcCharacterSkill(chref,skill)
		int color = COLOR_NORMAL
		skill = "skill"+skill
		GameInterface.strings.(skill) = modval
		if (skillVal >= modval)	{color = COLOR_GREEN;}
		if (skillVal <  modval)	{color = COLOR_MONEY;}
		if (skillVal == 0)		{color = COLOR_GRAY;}
		ChangeStringColor(skill,color)
	}
}
void ProcessChangeRole()
{
	SetSelectable("LEFTSCROLLBUTTON",false)
	SetSelectable("RIGHTSCROLLBUTTON",false)
	SetSelectable("PASSENGERS_LIST",false)
	SetSelectable("COMPAIN_LIST",false)
	SetSelectable("CHANGE_OFFICER_ROLE",false)
	SetSelectable("REMOVE_BUTTON",false)
	SetSelectDialogUsing(true)
}
void SetSelectDialogUsing(bool using)
{
	SetNodeUsing("SELECT_OFFICER_TYPE",using)
	SetNodeUsing("SELECT_FIRSTMATE",using)
	SetNodeUsing("SELECT_NAVIGATOR",using)
	SetNodeUsing("SELECT_GUNNER",using)
	SetNodeUsing("SELECT_BOATSWAIN",using)
	SetNodeUsing("SELECT_DOCTOR",using)
	SetNodeUsing("SELECT_CARPENTER",using)
	SetNodeUsing("SELECT_QMASTER",using)
	SetNodeUsing("SELECT_REMOVE",using)

	SetCurrentNode("SELECT_REMOVE")

	ref off = GetCharacter(indOfficer)

	if (off.quest.officertype == OFFIC_TYPE_NAVIGATOR) {
		SetCurrentNode("SELECT_OFFICER_TYPE")
	}
	if (off.quest.officertype == OFFIC_TYPE_FIRSTMATE) {
		SetCurrentNode("SELECT_FIRSTMATE")
	}
	if (off.quest.officertype == OFFIC_TYPE_NAVIGATOR) {
		SetCurrentNode("SELECT_NAVIGATOR")
	}
	if (off.quest.officertype == OFFIC_TYPE_CANNONEER) {
		SetCurrentNode("SELECT_GUNNER")
	}
	if (off.quest.officertype == OFFIC_TYPE_BOATSWAIN) {
		SetCurrentNode("SELECT_BOATSWAIN")
	}
	if (off.quest.officertype == OFFIC_TYPE_DOCTOR) {
		SetCurrentNode("SELECT_DOCTOR")
	}
	if (off.quest.officertype == OFFIC_TYPE_CARPENTER) {
		SetCurrentNode("SELECT_CARPENTER")
	}
	if (off.quest.officertype == OFFIC_TYPE_QMASTER) {
		SetCurrentNode("SELECT_QMASTER")
	}
}
void SelectFirstMate()
{
	SetCharacterRole(OFFIC_TYPE_FIRSTMATE)
}
void SelectNavigator()
{
	SetCharacterRole(OFFIC_TYPE_NAVIGATOR)
}
void SelectGunner()
{
	SetCharacterRole(OFFIC_TYPE_CANNONEER)
}
void SelectBoatswain()
{
	SetCharacterRole(OFFIC_TYPE_BOATSWAIN)
}
void SelectDoctor()
{
	SetCharacterRole(OFFIC_TYPE_DOCTOR)
}
void SelectCarpenter()
{
	SetCharacterRole(OFFIC_TYPE_CARPENTER)
}
void SelectQMaster()
{
	SetCharacterRole(OFFIC_TYPE_QMASTER)
}
void SelectRemove()
{
	SetCharacterRole(OFFIC_TYPE_ABORDAGE)
}
void SelectAbort()
{
	SetSelectDialogUsing(false)
	SetSelectable("LEFTSCROLLBUTTON",true)
	SetSelectable("RIGHTSCROLLBUTTON",true)
	SetSelectable("PASSENGERS_LIST",true)
	SetSelectable("COMPAIN_LIST",true)
	SetSelectable("CHANGE_OFFICER_ROLE",true)
	SetSelectable("REMOVE_BUTTON",true)
	SetCurrentNode("COMPAIN_LIST")
}
void SetCharacterRole(string officerType)
{
	int idx = GetOfficersIndex(refShip2,numFourImage)
	ref chr = GetCharacter(idx)
	if (officerType == OFFIC_TYPE_ABORDAGE) {
		bool del = true
		for (i=0; i<OFFICER_MAX; i++) {
			if (idx == GetOfficersIndex(refShip2,i)) {
				chr.quest.officertype = OFFIC_TYPE_ABORDAGE
				del = false
				break
			}
		}
		if (del && CheckAttribute(chr,"quest.officertype")) {
			DeleteAttribute(chr, "quest.officertype")
		}
	}
	else {
		chr.quest.officertype = officerType
	}
	SetSelectDialogUsing(false)
	RefreshScreen()
	SetCurrentNode("COMPAIN_LIST")
}
